/*! typed-dom v0.0.303 https://github.com/falsandtru/typed-dom | (c) 2016, falsandtru | (Apache-2.0 AND MPL-2.0) License */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["typed-dom"] = factory();
	else
		root["typed-dom"] = factory();
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 99:
/***/ ((__unused_webpack_module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.duffReduce = exports.duffEach = exports.duffbk = exports.duff = void 0;

function duff(count, proc) {
  if (count > 0) {
    let i = 0,
        m = count % 8,
        d = (count - m) / 8;

    while (m--) {
      proc(i++);
    }

    while (d--) {
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
    }
  } else {
    let i = -count,
        m = i % 8,
        d = (i - m) / 8;

    while (m--) {
      proc(--i);
    }

    while (d--) {
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
    }
  }
}

exports.duff = duff;

function duffbk(count, proc) {
  if (count > 0) {
    let i = 0,
        m = count % 8,
        d = (count - m) / 8;

    while (m--) {
      if (proc(i++) === false) return;
    }

    while (d--) {
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
    }
  } else {
    let i = -count,
        m = i % 8,
        d = (i - m) / 8;

    while (m--) {
      if (proc(--i) === false) return;
    }

    while (d--) {
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
    }
  }
}

exports.duffbk = duffbk;

function duffEach(array, proc) {
  let count = array.length;
  let i = 0,
      m = count % 8,
      d = (count - m) / 8;

  while (m--) {
    proc(array[i], i++, array);
  }

  while (d--) {
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
  }
}

exports.duffEach = duffEach;

function duffReduce(array, proc, initial) {
  let count = array.length;
  let i = 0,
      m = count % 8,
      d = (count - m) / 8;
  let acc = initial;

  while (m--) {
    acc = proc(acc, array[i], i++, array);
  }

  while (d--) {
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
  }

  return acc;
}

exports.duffReduce = duffReduce;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
var exports = __webpack_exports__;


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.querySelectorAll = exports.querySelectorAllWith = exports.querySelectorWith = void 0;

const duff_1 = __webpack_require__(99);

function querySelectorWith(node, selector) {
  return 'matches' in node && node.matches(selector) ? node : node.querySelector(selector);
}

exports.querySelectorWith = querySelectorWith;

function querySelectorAllWith(node, selector) {
  const acc = [];

  if ('matches' in node && node.matches(selector)) {
    acc.push(node);
  }

  return (0, duff_1.duffReduce)(node.querySelectorAll(selector), (acc, node) => (acc.push(node), acc), acc);
}

exports.querySelectorAllWith = querySelectorAllWith;

function querySelectorAll(node, selector) {
  return (0, duff_1.duffReduce)(node.querySelectorAll(selector), (acc, node) => (acc.push(node), acc), []);
}

exports.querySelectorAll = querySelectorAll;
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});